> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/api-reference/management/reseller/models.md).

# Models

## The UserResponseResource object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"UserResponseResource":{"type":"object","properties":{"id":{"type":"string","description":"The resource's unique identifier","readOnly":true},"href":{"type":"string","description":"URI for specific Admin in a Contract","format":"uri","readOnly":true},"firstName":{"type":"string","description":"first name of the user","readOnly":true},"lastName":{"type":"string","description":"last name of the user","readOnly":true},"email":{"type":"string","description":"email of the user","readOnly":true}}}}}}
```

## The UserRequestResource object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"UserRequestResource":{"required":["email","firstName","lastName","password"],"type":"object","properties":{"firstName":{"type":"string","description":"first name of the user"},"lastName":{"type":"string","description":"last name of the user"},"email":{"type":"string","description":"email of the user"},"password":{"type":"string","description":"password of the user"}}}}}}
```

## The UserUpdateRequestResource object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"UserUpdateRequestResource":{"required":["email","firstName","lastName"],"type":"object","properties":{"firstName":{"type":"string","description":"first name of the user"},"lastName":{"type":"string","description":"last name of the user"},"email":{"type":"string","description":"email of the user"}}}}}}
```

## The PaginatedContractResponseResource object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"PaginatedContractResponseResource":{"type":"object","properties":{"items":{"type":"array","description":"Array of items in the collection.","readOnly":true,"items":{"$ref":"#/components/schemas/ContractResponseResource"}},"offset":{"$ref":"#/components/schemas/PaginationOffsetOptional"},"limit":{"$ref":"#/components/schemas/PaginationLimitOptional"},"_links":{"$ref":"#/components/schemas/PaginationLinks"}}},"ContractResponseResource":{"type":"object","properties":{"id":{"type":"string","description":"The resource's unique identifier","readOnly":true},"href":{"type":"string","description":"URI for specific Contract","format":"uri","readOnly":true},"name":{"type":"string","description":"name of the contract"},"resellerReference":{"type":"string","description":"reseller reference of the contract"},"status":{"type":"string","description":"status of the contract"},"resourceLimits":{"$ref":"#/components/schemas/ResourceLimits"}}},"ResourceLimits":{"required":["cpuContractMax","cpuServerMax","hddVolumeContractMaxSize","hddVolumeMaxSize","ips","ramContractMax","ramServerMax","ssdVolumeContractMaxSize","ssdVolumeMaxSize"],"type":"object","properties":{"ramServerMax":{"type":"integer","description":"maximum ram per virtual machine","format":"int32"},"cpuServerMax":{"type":"integer","description":"maximum number of cpu per virtual machine","format":"int32"},"hddVolumeMaxSize":{"type":"integer","description":"maximum hdd volume size","format":"int32"},"ssdVolumeMaxSize":{"type":"integer","description":"maximum ssd volume size","format":"int32"},"ramContractMax":{"type":"integer","description":"maximum ram per contract","format":"int32"},"cpuContractMax":{"type":"integer","description":"maximum cpu per contract","format":"int32"},"hddVolumeContractMaxSize":{"type":"integer","description":"maximum hhd volume per contract","format":"int32"},"ssdVolumeContractMaxSize":{"type":"integer","description":"maximum ssd volume per contract","format":"int32"},"ips":{"type":"integer","description":"maximum ips per contract","format":"int32"}}},"PaginationOffsetOptional":{"type":"number","description":"The offset (if specified in the request)."},"PaginationLimitOptional":{"type":"number","description":"The limit (if specified in the request)."},"PaginationLinks":{"type":"object","properties":{"prev":{"type":"string","description":"URL (with offset and limit parameters) of the previous page; only present if offset is greater than 0.","format":"uri","readOnly":true},"self":{"type":"string","description":"URL (with offset and limit parameters) of the current page.","format":"uri","readOnly":true},"next":{"type":"string","description":"URL (with offset and limit parameters) of the next page; only present if offset + limit is less than the total number of elements.","format":"uri","readOnly":true}}}}}}
```

## The ContractResponseResource object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"ContractResponseResource":{"type":"object","properties":{"id":{"type":"string","description":"The resource's unique identifier","readOnly":true},"href":{"type":"string","description":"URI for specific Contract","format":"uri","readOnly":true},"name":{"type":"string","description":"name of the contract"},"resellerReference":{"type":"string","description":"reseller reference of the contract"},"status":{"type":"string","description":"status of the contract"},"resourceLimits":{"$ref":"#/components/schemas/ResourceLimits"}}},"ResourceLimits":{"required":["cpuContractMax","cpuServerMax","hddVolumeContractMaxSize","hddVolumeMaxSize","ips","ramContractMax","ramServerMax","ssdVolumeContractMaxSize","ssdVolumeMaxSize"],"type":"object","properties":{"ramServerMax":{"type":"integer","description":"maximum ram per virtual machine","format":"int32"},"cpuServerMax":{"type":"integer","description":"maximum number of cpu per virtual machine","format":"int32"},"hddVolumeMaxSize":{"type":"integer","description":"maximum hdd volume size","format":"int32"},"ssdVolumeMaxSize":{"type":"integer","description":"maximum ssd volume size","format":"int32"},"ramContractMax":{"type":"integer","description":"maximum ram per contract","format":"int32"},"cpuContractMax":{"type":"integer","description":"maximum cpu per contract","format":"int32"},"hddVolumeContractMaxSize":{"type":"integer","description":"maximum hhd volume per contract","format":"int32"},"ssdVolumeContractMaxSize":{"type":"integer","description":"maximum ssd volume per contract","format":"int32"},"ips":{"type":"integer","description":"maximum ips per contract","format":"int32"}}}}}}
```

## The ResourceLimits object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"ResourceLimits":{"required":["cpuContractMax","cpuServerMax","hddVolumeContractMaxSize","hddVolumeMaxSize","ips","ramContractMax","ramServerMax","ssdVolumeContractMaxSize","ssdVolumeMaxSize"],"type":"object","properties":{"ramServerMax":{"type":"integer","description":"maximum ram per virtual machine","format":"int32"},"cpuServerMax":{"type":"integer","description":"maximum number of cpu per virtual machine","format":"int32"},"hddVolumeMaxSize":{"type":"integer","description":"maximum hdd volume size","format":"int32"},"ssdVolumeMaxSize":{"type":"integer","description":"maximum ssd volume size","format":"int32"},"ramContractMax":{"type":"integer","description":"maximum ram per contract","format":"int32"},"cpuContractMax":{"type":"integer","description":"maximum cpu per contract","format":"int32"},"hddVolumeContractMaxSize":{"type":"integer","description":"maximum hhd volume per contract","format":"int32"},"ssdVolumeContractMaxSize":{"type":"integer","description":"maximum ssd volume per contract","format":"int32"},"ips":{"type":"integer","description":"maximum ips per contract","format":"int32"}}}}}}
```

## The ContractRequestResource object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"ContractRequestResource":{"required":["name","resourceLimits"],"type":"object","properties":{"name":{"type":"string","description":"name of the contract"},"resellerReference":{"type":"string","description":"reseller reference of the contract"},"resourceLimits":{"$ref":"#/components/schemas/ResourceLimits"}}},"ResourceLimits":{"required":["cpuContractMax","cpuServerMax","hddVolumeContractMaxSize","hddVolumeMaxSize","ips","ramContractMax","ramServerMax","ssdVolumeContractMaxSize","ssdVolumeMaxSize"],"type":"object","properties":{"ramServerMax":{"type":"integer","description":"maximum ram per virtual machine","format":"int32"},"cpuServerMax":{"type":"integer","description":"maximum number of cpu per virtual machine","format":"int32"},"hddVolumeMaxSize":{"type":"integer","description":"maximum hdd volume size","format":"int32"},"ssdVolumeMaxSize":{"type":"integer","description":"maximum ssd volume size","format":"int32"},"ramContractMax":{"type":"integer","description":"maximum ram per contract","format":"int32"},"cpuContractMax":{"type":"integer","description":"maximum cpu per contract","format":"int32"},"hddVolumeContractMaxSize":{"type":"integer","description":"maximum hhd volume per contract","format":"int32"},"ssdVolumeContractMaxSize":{"type":"integer","description":"maximum ssd volume per contract","format":"int32"},"ips":{"type":"integer","description":"maximum ips per contract","format":"int32"}}}}}}
```

## The Info object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"Info":{"type":"object","properties":{"href":{"type":"string","description":"API entry point","format":"uri","readOnly":true},"name":{"type":"string","description":"Name of the API","readOnly":true},"version":{"type":"string","description":"Version of the API","readOnly":true}}}}}}
```

## The ErrorResponse object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"ErrorResponse":{"type":"object","properties":{"httpStatus":{"type":"integer","description":"HTTP status code of the operation.","readOnly":true},"messages":{"type":"array","items":{"$ref":"#/components/schemas/ErrorMessage"}}}},"ErrorMessage":{"type":"object","properties":{"errorCode":{"type":"string","description":"IONOS CLOUD error code."},"message":{"type":"string","description":"Limit must not exceed 5,000."}}}}}}
```

## The ErrorMessage object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"ErrorMessage":{"type":"object","properties":{"errorCode":{"type":"string","description":"IONOS CLOUD error code."},"message":{"type":"string","description":"Limit must not exceed 5,000."}}}}}}
```

## The PaginationOffsetOptional object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"PaginationOffsetOptional":{"type":"number","description":"The offset (if specified in the request)."}}}}
```

## The PaginationLimitOptional object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"PaginationLimitOptional":{"type":"number","description":"The limit (if specified in the request)."}}}}
```

## The PaginationLinks object

```json
{"openapi":"3.0.1","info":{"title":"Reseller API","version":"2.0"},"components":{"schemas":{"PaginationLinks":{"type":"object","properties":{"prev":{"type":"string","description":"URL (with offset and limit parameters) of the previous page; only present if offset is greater than 0.","format":"uri","readOnly":true},"self":{"type":"string","description":"URL (with offset and limit parameters) of the current page.","format":"uri","readOnly":true},"next":{"type":"string","description":"URL (with offset and limit parameters) of the next page; only present if offset + limit is less than the total number of elements.","format":"uri","readOnly":true}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/api-reference/management/reseller/models.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
